<?php

/**
 * MyEventsTimeSheet
 *
 * @author Tomasz Świenty
 * @version 0.1
 * @copyright Copyright (c) eDokumenty
 */
final class MyEventsTimeSheet {


    /**
     * @var string|null
     */
    private $name;


    /**
     * MyEventsTimeSheet constructor.
     * @param array $params
     */
    public function __construct(array $params = []) {

        $this->name = $params[0] ?? NULL;

    }


    /**
     * @param $prc_id
     * @return string|null
     */
    public function renderWidget($prc_id) : ?string {

        if (!$this->name) {
            return NULL;
        }

        require_once('./scripts/MyEventsTimeSheet/MyEventsTimeSheetWidget.inc');

        $timesheetWidget = new MyEventsTimeSheetWidget($this->name.'metsw');
        $timesheetWidget->setContext(new Process($prc_id));
        $timesheetWidget->height = '100%';
        $timesheetWidget->width = '100%';
        $timesheetWidget->top = '';
        $timesheetWidget->right = '';
        $timesheetWidget->position = 'relative';
        $timesheetWidget->style = 'text-align:right; font-size:18px; color:#888;';

        return $timesheetWidget->toHtml();

    }

}