<?php
require_once('./classes/EventsTimeSheet/EventsTimeSheetWidget.inc');

/**
 * MyEventsTimeSheetWidget
 *
 * @author Tomasz Świenty
 * @version 0.1
 * @copyright Copyright (c) eDokumenty
 */
final class MyEventsTimeSheetWidget extends EventsTimeSheetWidget {


    /**
     * MyEventsTimeSheetWidget constructor.
     * @param null $name
     */
    public function __construct($name = NULL) {

        parent::__construct($name);

        $this->HWND = App::registerClass('./scripts/MyEventsTimeSheet/MyEventsTimeSheetWidget.inc', __CLASS__);

    }


    /**
     * @param bool $toHtml
     * @param bool $silentMode
     * @return string|null
     * @throws RequestAbortException
     */
    public function startEvent($toHtml = TRUE, $silentMode = FALSE) : ?string {

        $condition = TRUE;

        if ($condition === TRUE) {
            // własny dialog
            JScript::registerOnLoad('App.openDialogEx(\''.App::registerDialog(Application::getShortName('MyTodoCustomDialog'), 'MyTodoCustomDialog', './scripts/MyEventsTimeSheet/MyTodoCustomDialog.inc').'\', null, ({parent:\''.$this->name.'\', prc_id:'.($this->context['data']['prc_id'] ?? NULL).'}).toJSONString());');
        } else {
            // utworzenie zadania w tle i odpalenie rejestratora ręcznie
            require_once(MODEL_PATH.'Tasks/Todo.inc');
            $todo = new Todo();
            $todo->set('sumary', 'Jakiś temat '.time());
            $todo->set('dscrpt', 'Jakiś opis '.time());
            $todo->set('prc_id', ($this->context['data']['prc_id'] ?? NULL));
            $todo->set('emp_id', [LoggedUser::getUserID()]);
            $todo->save(TRUE);

            // odpalenie RCP recznie
            $timesheetWidget = new EventsTimeSheetWidget($this->name.'etswee');
            $timesheetWidget->setContext($todo);
            $timesheetWidget->startEvent(FALSE, TRUE);

            JScript::registerOnLoad('$jq(\'#'.$this->name.'\').hide();');
        }

        // nigdy nie wywołuje parenta bo poleci cały starndardowy kod
        return NULL;

    }

}